/************************************************************* 2005.9.13 *****/
//  Duffing1.c : `΂˂PRxn̋UiKj              //
//  E ddy/ddt + 2dy/dt +(1+y^2)*y = F*sin(z*t)                          //
//@E (1) ,  ݒ   (2) F, z ݒ    (3) ݒ                   //
//@E`ʍFUȐC@EFgCEFU}@\       //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          801
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2

float  ffred[]   ={0.1, 0.0, 0.0, 0.5};
static double zeta, zeta1, eps, OM0; //āC`
static double a, t, dt=0.02;
static double Force, Force1, z;      //O͐UCO͐U
static double Amps, Ampd, fai;       //Ý(m)CU(m)Cʑx(rad)
static double ylimit;                 //1-y^2<0ƂȂEy
static double yy0, vv0, yy1[2], yy2[2], yseries[3][MMAX];
static double FY[MMAX];              //퉞̃XyNg
static double aseries0[MMAX][3];     //w肵,F̎g
static double YY[3];                 //w肵ẑƂ̐UiőRʂj
static int    IZ;                    //̐U̐
static double aseries[10][MMAX][3];  //ĉς̎gQ
static double bseries[10][MMAX][3];  //O͂eς̎gQ
static int    my, nf;                //g̏cݐCȐ
static int    nvib, ncurve;          //`悷U}̃}X̐CUȐ̐
static int    nrkg=5;                //rkg()nrkgJԂlf[^Ƃ
static double r0[2], rc[2], rf[2];   //`挴_
static double r1[2], r2[2];
static double wt, wy[2];             //`ψʁExȐ̏c{
static double dy, wa, wz;            //nf{̎gȐ̏c݁Ec{E{
static double RF[2], WF, WA;         //g`XyNg}̌_E݁Ec{
static double arrow0[2], arrowl, alpha, arrowd;
static double transx, transy, rot;
static int    m, mm, n;              //g`̃f[^Eőf[^
static int    nsp;                   //g`XyNg
static int    sgnf;                  //ÉorO͂eς̎g̑I
static int    MotionSign;
unsigned char KEY;
void   rkg();
void   dialogue();
static double zeta0[]={0.0, 0.05, 0.1, 0.2, 0.5, 0.7071, 1.0, 2.0, 5.0};
static double FF0[]={0.05, 0.1, 0.2, 0.5, 1.0, 2.0, 5.0, 10.0, 20.0};
//double xedge=0.99;



/************** ̉ *********************************************/
double f(int i, double t, double y[])
{
   static double  yy, Fex;
   if(i==0) yy=y[1];
   if(i==1) 
   {
	   Fex = Force*sin(z*t);                     //O
	   yy  = ( Fex - (2*zeta*y[1] + (1 + eps*y[0]*y[0])*y[0]) );

//printf("\nt=%4.2f y[]=(%6.3f %6.4f) yy=%6.3f  Force=%7.4f, Fex=%7.4f"
//	   ,t,y[0],y[1],yy, Force,Fex);
	   
  }
   return yy;
}
/************* f() end *******************************************************/

/************* ǧvZ **********************************************/
//     U^ĐUvZ                                            //
//     wy݂ŁC0-m܂ł̐UɂāCUvZ                       //
//     ʂfy[][0,1]ւQ̐UCfy[][2]֐U                //
//     ̐őM                                                           //
//     (f,y)ƂKĂ                                               //
/*****************************************************************************/
void freqcharct(double wy, int m, double fy[MMAX][3])
{
	static double y, yy, Y, B, C, D, zz0, zz1;
	static int    i, id;

	fy[0][0] = fy[0][1] = 1.0e5;   fy[0][2] = 0;
	for(i=1;i<=m;i++)
	{
		y = i*wy;
		yy = y*y;
		Y = 1 + 3*eps/4*yy;
		B = Y - 2*zeta*zeta;
		C = Force*Force/yy - Y*Y;
		D = B*B + C;
		if(D<0) { id = i; goto f1; }
		D = sqrt(D);
		zz0 = B + D;   if(zz0>0)  fy[i][0] = sqrt(zz0);
		               else       fy[i][0] = -1;
		zz1 = B - D;   if(zz1>0)  fy[i][1] = sqrt(zz1);
		               else       fy[i][1] = -1;
		fy[i][2] = y;

/*
if(D>0)
printf("\ni=%3d  y=%7.4f  z*z[0,1]=(%7.4f %7.4f) z[0,1]=(%7.4f %7.4f)"
	   ,i,y,zz0,zz1,z[i][0],z[i][1]);
if(D<0)
printf("\ni=%3d  y=%7.4f  D=%7.4f z[0,1]=(%7.4f %7.4f)"
	   ,i,y,D,z[i][0],z[i][1]);
*/
	}
	goto end;

f1:
	y = y - wy;
	wy = 0.1*wy;
	for(i=id;i<=m;i++)
	{
		y = y + wy;
		yy = y*y;
		Y = 1 + 3*eps/4*yy;
		B = Y - 2*zeta*zeta;
		C = Force*Force/yy - Y*Y;
		D = B*B + C;
		if(D<0) fy[i][0] = fy[i][1] = -1;
		else
		{   D = sqrt(D);
			zz0 = B + D;   if(zz0>0)  fy[i][0] = sqrt(zz0);
			               else       fy[i][0] = -1;
			zz1 = B - D;   if(zz1>0)  fy[i][1] = sqrt(zz1);
			               else       fy[i][1] = -1;
			fy[i][2] = y;
		}
	}

end:;

//printf("\nL̓=%5.2f\n",zeta);
//getch();

}
/********* freqcharct() end ***************************************************/

/********* yz(z) **************************************************************/
//         aseries0[]zɑΉUT                         //
//    z       : U                                                      //
//    Y[]     : w肵ẑƂ̐U                                         //
//    id      : ̐i߂l)                                               //
/******************************************************************************/
int yz(double z, double Y[])
{
	static  int   i, id;
	static double diff0, diff1, ratio;

	id = 0;
	//--------- [0]niz傫jT ------------------------------//
	diff0 = aseries0[0][0] - z;
	for(i=1;i<my;i++)
	{
		diff1 = aseries0[i][0] - z;
		if(aseries0[i-1][0]>0 && aseries0[i][0]>0)
    	if(diff0*diff1<0)
		{
			ratio = diff1/(diff1 - diff0);
			Y[id] = aseries0[i][2] - ratio*(aseries0[i][2]-aseries0[i-1][2]);
			id++;
		}
	    diff0 = diff1;
	}
	//--------- [1]nizjT -------------------------------//
	diff0 = aseries0[0][1] - z;
	for(i=1;i<my;i++)
	{
		diff1 = aseries0[i][1] - z;
		if(aseries0[i-1][1]>0 && aseries0[i][1]>0)
		if(diff0*diff1<0)
		{
			ratio = diff1/(diff1 - diff0);
			Y[id] = aseries0[i][2] - ratio*(aseries0[i][2]-aseries0[i-1][2]);
			id++;
		}
	    diff0 = diff1;
	}

/*
	//---------- as0[][]i[0][1]ȂꏊjT ---------//
	for(i=0;i<nny0;i++)
	{
		diff0 = as0[i][0] - z;
		diff1 = as0[i][1] - z;
		if(diff0*diff1<0) { Y[id] = as0[i][2];  id++; }

	}
*/

	return id;
}
/************ yz() end ********************************************************/


/********** drawDuffing() *****************************************************/
//    Duffing̎̎g`
//    caseries[i][2], aseries[i][0,1]̃f[^
//    f[^͏X؂Ă̂łȂĂ_񂾂`悷
//    rf[]   : W_
//    wz, wa : c̔{
//    nf, my : Ȑ̖{Cf[^
/*******************************************************************************/
//	drawDuffing(rf, wz, wa, nf, my, aseries); 
void drawDuffing(double rf[], double wz, double wa, int my, double as[MMAX][3], float fcolor[])
{
	static int  i, i1, j, k;
	static double r1[2], r2[2], y;

	i1 = 0;
		//---------- [0]n=z傫̕` : n߂Pq̓_ -------------//
	    r1[0] = r1[1] = -1;
	    for(i=0;i<=my;i++)
		{
			if(as[i][0]<0)  { i1 = i-1; break; }
		    else
			{ r2[0] = rf[0] + wz*as[i][0];  r2[1] = rf[1] + wa*as[i][2];
		      if(r1[0]>0)  usrDrawLine2d( r1, r2, fcolor );
			}
 		    r1[0] = r2[0];   r1[1] = r2[1];
		}
		//---------- [1]nz̕` : rPq̓_ ------------//
		r1[0] = r1[1] = -1;
	    for(i=0;i<=my;i++)
		{
			if(as[i][1]<0)  { r2[0] = r2[1] = -1; }
		    else
			{ r2[0] = rf[0] + wz*as[i][1];  r2[1] = rf[1] + wa*as[i][2];
		      if(r1[0]>0)  usrDrawLine2d( r1, r2, fcolor );
			}
	    	r1[0] = r2[0];   r1[1] = r2[1];
		}

        //----------- [0],[1]Ƃ_ŌオlĂ[0],[1]Ȃ -------------//
		if(i1!=0 && as[i1][0]>0 && as[i1][1]>0)
		{ r1[0] = rf[0] + wz*as[i1][0];  r1[1] = rf[1] + wa*as[i1][2];
		  r2[0] = rf[0] + wz*as[i1][1];  r2[1] = r1[1];
		  usrDrawLine2d(r1, r2, fcolor );
		}
}
/**************** drawDuffing() end *************************************************/

/**************** spectrum() ********************************************************/
//    퉞̃XyNg                                                      //
//    m    : g`f[^(ȂƂPȂj                            //
//    y[]  : g`f[^                                                           //
//    FY[] : XyNgiUj                                                     //
//    II2  : ߂lDXyNg                                                   //  
/************************************************************************************/
int  spectrum(int m, double y[], double FY[])
{
	static int    i, k, I[10], M, II, II2;
	static double yy, Fc[MMAX], Fs[MMAX], yyy[MMAX];

	//----------- y[]=0 n߂ƍŌɋ؂܂łPƂ  yyy[] -------------//
	M = 0;
	yy = y[0];
	for(i=1;i<m;i++)
	{
		if(y[i]*yy<0) { I[M] = i; M++; }
		yy = y[i];
	}
	if(M<2) { printf("\n spectrum() m=%d ȂĂPȂDf[^蒼");
	          return (0); }
	M = 2*((M-1)/2);      //0琔ċO؂
	II = I[M] - I[0];    II2 = II/2;
	for(i=I[0];i<=I[M];i++) 	yyy[i-I[0]] = y[i];

	//------------ FourierWJ -----------------------------//
	FourierS( yyy, II, II2, Fc, Fs);
	for(i=0;i<II2;i++)  FY[i] = sqrt(Fc[i]*Fc[i] + Fs[i]*Fs[i]);

	return II2;
}
/******************** spectrum() end ****************************************************/







/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
/************************************************************************************/
int main(int argc, char *argv[])
{
	static int i, m, n;

	KEY = 'm';
	dialogue();
	DrawGL(&argc, argv);
}
/*************main() end ****************************************************/

/*********** dialogue() *****************************************************/
void dialogue(void)
{
	static int  i, k;

    if(KEY=='m')   goto d1;
    if(KEY=='f')   goto d2;
    if(KEY=='j')   goto d3;

d1:
	printf("\n`΂˂PRxUn(Duffing's equation)U̕`");
	printf("\nK@ddy/ddt + 2dy/dt + (1+y^2)*y = F*sin(z*t)");
	printf("\n\nL[́@(1) ΂˃}X_p[");
	printf("\n        @(2) ÓEO͐U");
	printf("\n        @(3) ");

	//----------- n̒萔ݒ -------------------------------------------------//
	printf("\n\n(1) āC`Á@L[.  <0ł͕sɂȂՂ");
	printf("\n       =");
	scanf("%lf %lf", &zeta, &eps);

	if(zeta<=1)  OM0 = sqrt(1 - zeta*zeta); 
	printf("\n`ŗLU0=1.0[rad/s], =%7.4f",zeta);
	if(zeta<=1) printf("\n`ŗLU=%7.4f[rad/s]",OM0);
	if(eps<0) { ylimit = sqrt(-1.0/eps);   printf("\n=%6.3f  Eylimit=%7.4f",eps,ylimit); }

d2:
	//------------------ O͏ݒ ---------------------------------------------//
	printf("\n\n(2) ΂˒萔K=1[N/m], UUF[N]CUz=(/0)@L[");
	printf("\n    z<1̂ƂCgDaL[Ŕg`̃XyNg");
	printf("\n    z>3̂ƂCgDaL[Ŕg`̃XyNg");
	printf("\n    C肭ƂȂƐȂ");
	printf("\n      F z=");
	scanf("%lf %lf",&Force,&z);
	Amps = Force;
	Ampd = Force/sqrt( (1-z*z)*(1-z*z) + (2*zeta*z)*(2*zeta*z) );
	fai = atan2( 2*zeta, (1-z*z) );
	printf("\n`̐Ý   Amps=%7.4f[m]",Amps);
    printf("\n`̒U Ad=%7.4f[m], ʑxꃳ=%6.2f[deg]",Ampd,fai/RAD);
	if(Amps!=0)  printf("\nUAd/As=%7.4f",Ampd/Amps);


	//---------------- gvZ ------------------------------------//
    dy = 0.005;  my = 600;
    freqcharct(dy, my, aseries0);        //w肵ĂɂĂ̎g
    IZ = yz( z, YY );

	//------------- ĉς̎gQvZ ----------------------------//
	zeta1 = zeta;
    nf = 9;
    for(k=0;k<nf;k++)
	{
		zeta = zeta0[k];
        freqcharct(dy, my, aseries[k]);  //̃ĂɂĂ̎g
	}
	zeta = zeta1;
	//------------- O͂eς̎gQvZ ------------------------//
	Force1 = Force;
    nf = 9;
    for(k=0;k<nf;k++)
	{
		Force = FF0[k];
        freqcharct(dy, my, bseries[k]);  //̃ĂɂĂ̎g
	}
	Force = Force1;
d3:
	//------------------ ݒ ---------------------------------//
	printf("\n\n(4) ");
	printf("\n <0.2, z>1ɂ (y0 v0)=(0 0)ƂƏUC=(0 )ƂƑ傫U");
	printf("\n ā1, z>3ɂ (y0 v0)=(0 -)Ƃƕg邱Ƃ");
	printf("\n ́@y0 v0 = ");
	scanf("%lf %lf",&yy0, &vv0);

    //-------------- L[̂ύX ---------------//
    printf("\nUȐ`\@ԁF@΁FO\n");
	printf("\n's'L[ FU`p             'Y' 'y'L[ŁFg̏c{");
	printf("\n'm'L[   Fn̒萔i,ÁjύX  'T' 't'L[ŁFUȐ̎ԎLk");
	printf("\n'f'L[   FOF,zύX            'e' 'E'L[ŁForeςfI");
	printf("\n'j'L[   Fy0,v0ύX      'a'L[    Fg`̃XyNg`");
	printf("\nESCL[   FI\n");
//	getch();

	yy2[0] = yy0;
	yy2[1] = vv0;
    t = 0;
	m = 0;

	//---g`rf[]_C{wzCc{waCnf{̋ȐCemy̓_--------//
	r0[0] = 0.01;   r0[1] = 0;         //{_
	rc[0] = -0.99;  rc[1] = 0;         //UȐ_
    rf[0] = r0[0];  rf[1] = r0[1];     //g_
	wa = 0.5;                          //gc{(wa=0.5:y=1m)
	wz = 0.25;                         //g{(wz=0.25:UU)
	nvib = 1;                          //`}X̐
	//--- UȐ`Fr0[]_CwtԎCwy[]cCn{ȐCm̓_CUy[i][k]--//
	wt = 0.005;                        //UȐԍ
	mm = 1.0/wt;                       //UȐ_
//	y[0] = wa; 	
	wy[0] = wa; wy[1] = wa;//UȐc{
	ncurve = 2;                        //`Ȑ
	//--- g`̃XyNgFRF[]_CWF݁CWAc{CM̓_CFY[]XyNg ----//
	RF[0] = r0[0];  RF[1] = r0[1] - 0.8;
	WF = 0.05;  WA = wa;
//	void drawbargraph(double rf[], double wf, double wa, int m, double a[])

}

/************ dialogue() end ****************************************************/


/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("Duffing̎@m:n f:O j: ύX, s:`p,@y,Y:fc{ύX t,T:ԎLk, a:g`XyNg");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i, k;

	usrSetting();

	//-------- ̉ ------//
	for(i=0;i<nrkg;i++)
	{
		yy1[0] = yy2[0];
	    yy1[1] = yy2[1];
	    rkg1( t, dt, yy1, yy2, 2);
		t = t + dt;
	}

//printf("\nmain() rkg()  m=%3d",m);
//printf("\n yy2[]=(%7.4f %7.4f)",yy2[0],yy2[1]);


	//---U}`Fr0[]_Cwyc{Cn}X̐Cyy2[0]U-------------------//
//void drawcharacter(GLfloat x, GLfloat y, void *font, char *string)
    drawcharacter(-0.95, 0.95, H18, "red    : response y(t)");
    drawcharacter(-0.95, 0.90, H18, "green  : external force f(t)/K");
    drawcharacter(-0.95, 0.85, H18, "1grid=(2s,0.2m)");
	wy[0] = wa;
	drawfigure(r0, wy[0], nvib, &yy2[0] );                          //}X̐U
	//-----------------O͂ŕ\ ----------------------------------------//
	arrowl = 0.3*sin(z*t)*wy[0];   alpha = PAI/2; arrowd = 0.04;
	if(arrowl<0) { alpha = -alpha;   arrowd = -arrowd; }
	arrowl = fabs(arrowl);  
    arrow0[0] = r0[0] + 0.5*(xedge - r0[0]);       //̐[}X̏㉺0.04̈ʒu
	arrow0[1] = r0[1] + yy2[0]*wy[0] - arrowd;
	usrDrawArrow2d( arrow0, arrowl, alpha, green ); 
//	void usrDrawArrow2d( double r0[], double a, double alpha, GLfloat color[] )

	//--- Ȑ`  0:}X̐U@1:O --------------------//
	//--- r0[]_CwtԎCwy[]cCn{ȐCm̓_CUy[i][k]--//
    //  	wt = 0.005; wy[0] = wy[1] = wa = 0.5;  ncurve = 2;
    wy[0] = wy[1] = wa;
	m++;  if( m > 1.0/wt ) m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = Force*sin(z*t);
	usrDrawAxis2d( rc, 0.0 );
	r1[0] = r0[0] - 60*wt/(nrkg*dt);   r1[1] = r0[1];
    usrGrating( r1, 0.0, 30, 2*wt/(nrkg*dt), 0.2*wa );
	drawcurven( rc, wt, wy, ncurve, m, yseries, MMAX );               //UȐ


	//---g`Frf[]_C{wzCc{waCnf{̋ȐCemy̓_--------//
	if(sgnf=='e')
	{
    drawcharacter(-0.1, 0.9,  H18, "blue : zeta={0, 0.05, 0.1, 0.2, 0.5, 1, 2, 5, 10}");
    drawcharacter(-0.1, 0.85, H18, "red curve : given zeta");
	for(k=0;k<nf;k++)
	drawDuffing(rf, wz, wa, my, aseries[k], blue ); 
	}
	if(sgnf=='E')
	{
    drawcharacter(-0.1, 0.9,  H18, "blue : Force={0.05, 0.1, 0.2, 0.5, 1, 2, 5, 10, 20}");
    drawcharacter(-0.1, 0.85, H18, "red curve : given Force");
	for(k=0;k<nf;k++)
	drawDuffing(rf, wz, wa, my, bseries[k], blue ); 
	}
    drawcharacter(-0.1, 0.8,  H18, "blue line : z=1,  green line : given z");
//  rf[0] = r0[0];      rf[1] = r0[1];
//	wa = 0.5;   	    wz = 0.25;
	r1[0] = rf[0] + wz;    r1[1] = rf[1];
	r2[0] = r1[0];         r2[1] = r1[1] + 5.0;
    usrDrawLine2d(r1, r2, blue );          //z=1(UU)c
	r1[0] = rf[0] + wz*z;  r1[1] = rf[1];
	r2[0] = r1[0];         r2[1] = rf[1] + 5.0;
    usrDrawLine2d(r1, r2, green );        //z(UĂU)c
	drawDuffing(rf, wz, wa, my, aseries0, red );
	for(k=0;k<IZ;k++)                     //w肵ẑƂ̐U\
	{   r1[0] = rf[0] + wz*z;    r1[1] = rf[1] + wa*YY[k];
		usrDrawSolidCircle2d(r1, 0.01, green );
	}
	//------------ <0̂ƂEylimit` --------------------------------//
	if(eps<0) { r1[0] = rf[0];        r1[1] = rf[1] + wa*ylimit;
	            r2[0] = r1[0] + 5.0;  r2[1] = r1[1];
                usrDrawLine2d(r1, r2, black );   //z(UĂU)c
                drawcharacter(-0.1, 0.75,  H18, "black line : stable limit");
              }

	//------ g`̃XyNg` ------------------------------------------------//
	if(KEY=='a')
	{
        drawcharacter(0.05, -0.86, H18, "spectrum of response");
		drawbargraph( RF, WF, WA, nsp, FY);
	    r2[0] = RF[0] + 2.0; r2[1] = RF[1];
        usrDrawLine2d(RF, r2, red );     //XyNg̉
	}


	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/


/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	KEY = key;

	if(key=='s')       //U`p
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='y' || key=='Y')    //g̏c{
	{
		if(key=='y')  wa =  0.9*wa;
		if(key=='Y')  wa = wa/0.9;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='t' || key=='T')    //UȐԎLk
	{
		if(key=='t')  wt =  0.9*wt;
		if(key=='T')  wt = wt/0.9;
		mm = 1.0/wt;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='e' || key=='E')    //ĉρEeς̑I
	{
		sgnf = key;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='a')                 //g`̃XyNg
	{
		nsp = spectrum(m, yseries[0], FY);
		MotionSign = 0;
		usrdisplay();
		goto end;
	}
	if(key=='m' || key=='f' || key=='j')  //p[^EύX
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='\033')   exit(0);
	else              usrdisplay();

end:;
}

void motion_function(void){ }
